TrueChartsClone/.github/scripts/fetch_helm_deps.sh

165 lines
6.3 KiB
Bash
Raw Normal View History

#!/bin/bash
# require go-yq
command -v go-yq >/dev/null 2>&1 || {
printf >&2 "%s\n" "❌ go-yq (https://github.com/mikefarah/yq) is not installed. Aborting."
exit 1
}
# define defaults
cache_path=${cache_path:-./tgz_cache}
charts_path=${charts_path:-./charts}
# Do NOT persist this directory, in order to always have the latest index for this run.
index_cache=${index_cache:-./index_cache}
mkdir -p "$cache_path"
trains=(
"enterprise"
"stable"
"incubator"
"dependency"
"operators"
)
load_gpg_key() {
echo ""
echo "⏬ Downloading and Loading TrueCharts pgp Public Key"
gpg_dir=.cr-gpg
chore(ci): Improved lint speed (#8809) **Description** <!-- Please include a summary of the change and which issue is fixed. Please also include relevant motivation and context. List any dependencies that are required for this change. --> ⚒️ Fixes # <!--(issue)--> TODO: Switch to scripted checks (To replace ct-list's tasks): - [x] Helm Lint - [x] Version Checking - [x] Run the lint inside the devcontainer (so it have the below tools available) - [x] YAML Schema check on Chart.yaml - [ ] Maintener check on Chart.yaml (Moved to another PR in the future) - [x] YAML Lint on Chart.yaml - [x] YAML Lint on values.yaml - [x] Sort output of lint results (failed on the bottom) - [x] Combine verify deps in the lint job, since the verification runs inside the fetch dep (which runs on lint job too) - [x] Remove one of the 2 "get changed" functions (one based on tags other on commit) After that, move linting to single step https://github.com/helm/chart-testing/blob/main/pkg/tool/linter.go https://github.com/helm/chart-testing/blob/main/pkg/tool/account.go **⚙️ Type of change** - [ ] ⚙️ Feature/App addition - [ ] 🪛 Bugfix - [ ] ⚠️ Breaking change (fix or feature that would cause existing functionality to not work as expected) - [x] 🔃 Refactor of current code **🧪 How Has This Been Tested?** <!-- Please describe the tests that you ran to verify your changes. Provide instructions so we can reproduce. Please also list any relevant details for your test configuration --> **📃 Notes:** <!-- Please enter any other relevant information here --> **✔️ Checklist:** - [x] ⚖️ My code follows the style guidelines of this project - [x] 👀 I have performed a self-review of my own code - [x] #️⃣ I have commented my code, particularly in hard-to-understand areas - [x] 📄 I have made corresponding changes to the documentation - [x] ⚠️ My changes generate no new warnings - [x] 🧪 I have added tests to this description that prove my fix is effective or that my feature works - [x] ⬆️ I increased versions for any altered app according to semantic versioning **➕ App addition** If this PR is an app addition please make sure you have done the following. - [ ] 🪞 I have opened a PR on [truecharts/containers](https://github.com/truecharts/containers) adding the container to TrueCharts mirror repo. - [ ] 🖼️ I have added an icon in the Chart's root directory called `icon.png` --- _Please don't blindly check all the boxes. Read them and only check those that apply. Those checkboxes are there for the reviewer to see what is this all about and the status of this PR with a quick glance._
2023-05-23 08:26:41 +00:00
mkdir -p "$gpg_dir"
curl --silent https://keybase.io/truecharts/pgp_keys.asc | gpg --dearmor > $gpg_dir/pubring.gpg || echo "❌ Couldn't load Public Key."
echo "✅ Public Key loaded successfully..."
echo ""
}
export -f load_gpg_key
download_deps() {
local train_chart="$1"
# Extract dependencies for the Chart
deps=$(go-yq '.dependencies' "$charts_path/$train_chart/Chart.yaml")
# Find how many deps exist, so we can loop through them
length=$(echo "$deps" | go-yq '. | length')
echo "🤖🔨 Processing <$charts_path/$train_chart>... Dependencies: $length"
echo ""
for idx in $(eval echo "{0..$length}"); do
# Retrieve info for the dep in the current index..
curr_dep=$(echo "$deps" | pos="$idx" go-yq '.[env(pos)]')
if [ ! "$curr_dep" == null ]; then
name=$(echo "$curr_dep" | go-yq '.name')
version=$(echo "$curr_dep" | go-yq '.version')
repo=$(echo "$curr_dep" | go-yq '.repository')
# Remove http:// or https:// from url to create a dir name
repo_dir="${repo#http://}"
repo_dir="${repo#https://}"
echo "**********"
echo "🔗 Dependency: $name"
echo "🆚 Version: $version"
echo "🏠 Repository: $repo"
echo ""
if [ -f "$cache_path/$repo_dir/$name-$version.tgz" ]; then
echo "✅ Dependency exists in cache..."
else
echo "🤷‍♂️ Dependency does not exists in cache..."
repo_url="$repo/index.yaml"
if [ -f "$index_cache/$repo_dir/index.yaml" ]; then
echo "✅ Index for <$repo> exists!"
else
echo "⏬ Index for <$repo> is missing. Downloading from <$repo_url>..."
mkdir -p $index_cache/$repo_dir
wget --quiet "$repo_url" -O "$index_cache/$repo_dir/index.yaml"
if [ ! $? ]; then
echo "❌ wget encountered an error..."
exit 1
fi
if [ -f "$index_cache/$repo_dir/index.yaml" ]; then
echo "✅ Downloaded index for <$repo>!"
else
echo "❌ Failed to download index for <$repo> from <$repo_url>"
exit 1
fi
fi
# At the time of writing this, only 1 url existed (.urls[0]) pointing to the actual tgz.
# Extract url from repo_url. It's under .entries.DEP_NAME.urls. We filter the specific version first (.version)
dep_url=$(v="$version" n="$name" go-yq '.entries.[env(n)].[] | select (.version == env(v)) | .urls.[0]' "$index_cache/$repo_dir/index.yaml")
echo ""
echo "⏬ Downloading dependency $name-$version from $dep_url..."
mkdir -p "$cache_path/$repo_dir"
wget --quiet "$dep_url" -P "$cache_path/$repo_dir"
wget --quiet "$dep_url.prov" -P "$cache_path/$repo_dir"
if [ ! $? ]; then
echo "❌ wget encountered an error..."
if [[ "$train_chart" =~ incubator\/.* ]]; then
helm dependency build "$charts_path/$train_chart/Chart.yaml" || \
helm dependency update "$charts_path/$train_chart/Chart.yaml"|| exit 1
else
helm dependency build "$charts_path/$train_chart/Chart.yaml" --verify --keyring $gpg_dir/pubring.gpg || \
helm dependency update "$charts_path/$train_chart/Chart.yaml" --verify --keyring $gpg_dir/pubring.gpg || exit 1
fi
fi
if [ -f "$cache_path/$repo_dir/$name-$version.tgz" ]; then
echo "✅ Dependency Downloaded!"
if [[ ! "$train_chart" =~ incubator\/.* ]]; then
echo "Validating dependency signature..."
helm verify $cache_path/$repo_dir/$name-$version.tgz --keyring $gpg_dir/pubring.gpg || \
helm verify $cache_path/$repo_dir/$name-$version.tgz --keyring $gpg_dir/pubring.gpg || exit 1
else
echo "Skipping dependency signature verification for $train_chart..."
fi
else
echo "❌ Failed to download dependency"
# Try helm dependency build/update or otherwise fail fast if a dep fails to download...
if [[ "$train_chart" =~ incubator\/.* ]]; then
helm dependency build "$charts_path/$train_chart/Chart.yaml" || \
helm dependency update "$charts_path/$train_chart/Chart.yaml"|| exit 1
else
helm dependency build "$charts_path/$train_chart/Chart.yaml" --verify --keyring $gpg_dir/pubring.gpg || \
helm dependency update "$charts_path/$train_chart/Chart.yaml" --verify --keyring $gpg_dir/pubring.gpg || exit 1
fi
fi
fi
echo ""
mkdir -p "$charts_path/$train_chart/charts"
echo "📝 Copying dependency <$name-$version.tgz> to <$charts_path/$train_chart/charts>..."
cp "$cache_path/$repo_dir/$name-$version.tgz" "$charts_path/$train_chart/charts"
if [ -f "$charts_path/$train_chart/charts/$name-$version.tgz" ]; then
echo "✅ Dependency copied!"
echo ""
else
echo "❌ Failed to copy dependency"
# Try helm dependency build/update or otherwise fail fast if a dep fails to copy...
chore(ci): Improved lint speed (#8809) **Description** <!-- Please include a summary of the change and which issue is fixed. Please also include relevant motivation and context. List any dependencies that are required for this change. --> ⚒️ Fixes # <!--(issue)--> TODO: Switch to scripted checks (To replace ct-list's tasks): - [x] Helm Lint - [x] Version Checking - [x] Run the lint inside the devcontainer (so it have the below tools available) - [x] YAML Schema check on Chart.yaml - [ ] Maintener check on Chart.yaml (Moved to another PR in the future) - [x] YAML Lint on Chart.yaml - [x] YAML Lint on values.yaml - [x] Sort output of lint results (failed on the bottom) - [x] Combine verify deps in the lint job, since the verification runs inside the fetch dep (which runs on lint job too) - [x] Remove one of the 2 "get changed" functions (one based on tags other on commit) After that, move linting to single step https://github.com/helm/chart-testing/blob/main/pkg/tool/linter.go https://github.com/helm/chart-testing/blob/main/pkg/tool/account.go **⚙️ Type of change** - [ ] ⚙️ Feature/App addition - [ ] 🪛 Bugfix - [ ] ⚠️ Breaking change (fix or feature that would cause existing functionality to not work as expected) - [x] 🔃 Refactor of current code **🧪 How Has This Been Tested?** <!-- Please describe the tests that you ran to verify your changes. Provide instructions so we can reproduce. Please also list any relevant details for your test configuration --> **📃 Notes:** <!-- Please enter any other relevant information here --> **✔️ Checklist:** - [x] ⚖️ My code follows the style guidelines of this project - [x] 👀 I have performed a self-review of my own code - [x] #️⃣ I have commented my code, particularly in hard-to-understand areas - [x] 📄 I have made corresponding changes to the documentation - [x] ⚠️ My changes generate no new warnings - [x] 🧪 I have added tests to this description that prove my fix is effective or that my feature works - [x] ⬆️ I increased versions for any altered app according to semantic versioning **➕ App addition** If this PR is an app addition please make sure you have done the following. - [ ] 🪞 I have opened a PR on [truecharts/containers](https://github.com/truecharts/containers) adding the container to TrueCharts mirror repo. - [ ] 🖼️ I have added an icon in the Chart's root directory called `icon.png` --- _Please don't blindly check all the boxes. Read them and only check those that apply. Those checkboxes are there for the reviewer to see what is this all about and the status of this PR with a quick glance._
2023-05-23 08:26:41 +00:00
helm dependency build "$charts_path/$train_chart/Chart.yaml" || \
helm dependency update "$charts_path/$train_chart/Chart.yaml" || exit 1
fi
fi
done
}
chore(ci): Improved lint speed (#8809) **Description** <!-- Please include a summary of the change and which issue is fixed. Please also include relevant motivation and context. List any dependencies that are required for this change. --> ⚒️ Fixes # <!--(issue)--> TODO: Switch to scripted checks (To replace ct-list's tasks): - [x] Helm Lint - [x] Version Checking - [x] Run the lint inside the devcontainer (so it have the below tools available) - [x] YAML Schema check on Chart.yaml - [ ] Maintener check on Chart.yaml (Moved to another PR in the future) - [x] YAML Lint on Chart.yaml - [x] YAML Lint on values.yaml - [x] Sort output of lint results (failed on the bottom) - [x] Combine verify deps in the lint job, since the verification runs inside the fetch dep (which runs on lint job too) - [x] Remove one of the 2 "get changed" functions (one based on tags other on commit) After that, move linting to single step https://github.com/helm/chart-testing/blob/main/pkg/tool/linter.go https://github.com/helm/chart-testing/blob/main/pkg/tool/account.go **⚙️ Type of change** - [ ] ⚙️ Feature/App addition - [ ] 🪛 Bugfix - [ ] ⚠️ Breaking change (fix or feature that would cause existing functionality to not work as expected) - [x] 🔃 Refactor of current code **🧪 How Has This Been Tested?** <!-- Please describe the tests that you ran to verify your changes. Provide instructions so we can reproduce. Please also list any relevant details for your test configuration --> **📃 Notes:** <!-- Please enter any other relevant information here --> **✔️ Checklist:** - [x] ⚖️ My code follows the style guidelines of this project - [x] 👀 I have performed a self-review of my own code - [x] #️⃣ I have commented my code, particularly in hard-to-understand areas - [x] 📄 I have made corresponding changes to the documentation - [x] ⚠️ My changes generate no new warnings - [x] 🧪 I have added tests to this description that prove my fix is effective or that my feature works - [x] ⬆️ I increased versions for any altered app according to semantic versioning **➕ App addition** If this PR is an app addition please make sure you have done the following. - [ ] 🪞 I have opened a PR on [truecharts/containers](https://github.com/truecharts/containers) adding the container to TrueCharts mirror repo. - [ ] 🖼️ I have added an icon in the Chart's root directory called `icon.png` --- _Please don't blindly check all the boxes. Read them and only check those that apply. Those checkboxes are there for the reviewer to see what is this all about and the status of this PR with a quick glance._
2023-05-23 08:26:41 +00:00
export -f download_deps
load_gpg_key
if [ -z "$1" ]; then
for train in "${trains[@]}"; do
for chart in $(ls "$charts_path/$train"); do
download_deps "${train}/${chart}"
done
done
else
download_deps "$1"
fi